#!/usr/bin/env python
#encoding: utf-8

"""

YPT-230
Viz poznamky v mididings_DGX-660B.py
tento script prave funguje mezi YPT-230 a Fatarem.

"""
#scenes #=ID &": Scene("""& NAME & """, Pass(), Ctrl(1, 1, 0," & MBB & ") >> Ctrl(1, 1, 32, "& LSB &") >> Program(1, 1, "& PRG &" )),"

from mididings import *

run(
    scenes = {
1:  Scene("Grand Piano1", 	Pass(), 	Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 1 )),
7:  Scene("Harpsichord", 	Pass(), 	Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 0) >> Program(1, 1, 7 )),
8:  Scene("Harpsichord KSP", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 1) >> Program(1, 1, 7 )),
9:  Scene("Harpsichord 2", 	Pass(), 	Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 35) >> Program(1, 1, 7 )),
20:  Scene("Light Organ", 	Pass(), 	Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 33) >> Program(1, 1, 18 )),
21:  Scene("Church Organ 3", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 32) >> Program(1, 1, 20 )),
23:  Scene("Church Organ 2", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 35) >> Program(1, 1, 20 )),
24:  Scene("Notre Dame", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 40) >> Program(1, 1, 20 )),
25:  Scene("Organ Flute", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 64) >> Program(1, 1, 20 )),
26:  Scene("Tremolo Organ Flute", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 65) >> Program(1, 1, 20 )),
27:  Scene("Puff Organ", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 40) >> Program(1, 1, 21 )),
33:  Scene("Finger Dark", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 18) >> Program(1, 1, 34 )),
34:  Scene("Finger Slap Bass", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 43) >> Program(1, 1, 34 )),
35:  Scene("Finger Bass 2", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 45) >> Program(1, 1, 34 )),
36:  Scene("Fretless Bass", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 0) >> Program(1, 1, 36 )),
113:  Scene("Church Bells", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 96) >> Program(1, 1, 15 )),

#Scene(name, patch, init_patch=None)
128:	Scene("split piano/bass",
			KeySplit('f#2', Channel(2),Channel(3) ) , #f#2 včetně jde nahoru
			#Channel(2) >> KeySplit('f#2', Channel(2),Channel(3) ) , #f#2 včetně jde nahoru
			#Ctrl(port, channel, ctrl, value)
			# napred si v pre nastavi rejstriky na 2.a 3. kanal a pak prichozi noty splituje do jednotlivych kanalu, podle vyse noty.
			[Ctrl(1, 3, 0,0) >> Ctrl(1, 3, 32, 112) >> Program(1, 3, 1 ), #piano
			 Ctrl(1, 2, 0,0) >> Ctrl(1, 2, 32, 0) 	>> Program(1, 2, 36 ) ] #bass
			),
127:	Scene("split piano+housle/bass",
			KeySplit('f#2', Channel(2),[Channel(3),Channel(4)]), #f#2 včetně jde nahoru
			#Ctrl(port, channel, ctrl, value)
			[Ctrl(1, 4, 0,0) >> Ctrl(1, 4, 32, 0) 	>> Program(1, 4, 50 ),	#housle
			 Ctrl(1, 3, 0,0) >> Ctrl(1, 3, 32, 112) >> Program(1, 3, 1 ),	#piano
			 Ctrl(1, 2, 0,0) >> Ctrl(1, 2, 32, 0)	>> Program(1, 2, 36 )]	#bass
			),
126:	Scene("split vibrafone/bass",
			KeySplit('f#2', Channel(2),Channel(3)), #f#2 včetně jde nahoru
			#Ctrl(port, channel, ctrl, value)
			# napred si v pre nastavi rejstriky na 2.a 3. kanal a pak prichozi noty splituje do jednotlivych kanalu, podle vyse noty.
			[Ctrl(1, 3, 0,0) >> Ctrl(1, 3, 32, 0)	>> Program(1, 3, 12 ), #vibrafone
			 Ctrl(1, 2, 0,0) >> Ctrl(1, 2, 32, 0)	>> Program(1, 2, 36 )] #bass
			),
125:	Scene("Mixtura", Pass() // Transpose(7) // Transpose(12)), #ProgramFilter(program, ...)
124:	Scene("Split hluboky/vysoky housle",
		   KeySplit('f3', Transpose(-12) ,Pass()),
		   Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 49 )
		   ),
123:	Scene("split hluboky/vysoky", KeySplit('c3', Transpose(-12) ,Transpose(12) )),
    }, #toto je konec scenes={}

    #control =  ChannelFilter(15) >> Filter(PROGRAM) >> SceneSwitch(), #~Filter(CTRL) >> nefunguje
    #control =  Filter(PROGRAM) >> SceneSwitch(), #~Filter(CTRL) >> funguje
    #control =  ChannelFilter(15) >> Channel(1) >> Filter(PROGRAM) >> SceneSwitch(), #~Filter(CTRL) >> funguje
    control =  ChannelSplit({(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15): Filter(CTRL|PROGRAM), (16):Channel(1) >> Filter(PROGRAM) >> SceneSwitch()}),
    pre = ~Filter(PROGRAM) >> ~ChannelFilter(15)
)
