#!/usr/bin/env python
#encoding: utf-8

"""
 DGX-660B
	Zjednodusene na kanal 1. Co nejmin ukonu, aby to zvladalo i Raspberry, ale problem s vysicimi nastroji muze byt jinde - buffer ap.
	vice viz soubor mididings_DGX-660B.py

"""
#scenes #=ID &": Scene("""& NAME & """, Pass(), Ctrl(1, 1, 0," & MBB & ") >> Ctrl(1, 1, 32, "& LSB &") >> Program(1, 1, "& PRG &" )),"

from mididings import *


run(
    scenes = {
1:	Scene("Natural! Grand Piano", Pass(), Ctrl(1, 1, 0,108) >> Ctrl(1, 1, 32, 0) >> Program(1, 1, 1 )),
2:	Scene("Ambient Grand Piano", Pass(), Ctrl(1, 1, 0,108) >> Ctrl(1, 1, 32, 28) >> Program(1, 1, 1 )),
3:	Scene("Honky Tonk Piano", Pass(), Ctrl(1, 1, 0,108) >> Ctrl(1, 1, 32, 0) >> Program(1, 1, 4 )),
4:	Scene("Harpsichord", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 7 )),
5:	Scene("Harpsichord 1", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 0) >> Program(1, 1, 7 )),
6:	Scene("Harp", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 47 )),
7:	Scene("70s Percussive Organ", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 24) >> Program(1, 1, 18 )),
8:	Scene("Chapel Organ", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 113) >> Program(1, 1, 20 )),
9:	Scene("Jazz Organ 1", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 17 )),
10:	Scene("Rock Organ", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 19 )),
11:	Scene("Traditional Accordion", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 113) >> Program(1, 1, 22 )),
12:	Scene("Finger Bass", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 34 )),
13:	Scene("Jazz Rhythm", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 40) >> Program(1, 1, 33 )),
14:	Scene("Vox Humana", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 54 )),
15:	Scene("Choir", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 53 )),
16:	Scene("String Ensemble", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 49 )),
17:	Scene("Insomnia", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 113) >> Program(1, 1, 95 )),
18:	Scene("Warm Strings", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 40) >> Program(1, 1, 50 )),
19:	Scene("Choir Strings", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 40) >> Program(1, 1, 53 )),
20:	Scene("Nylon Guitar", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 25 )),
21:	Scene("Clean Guitar", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 28 )),
22:	Scene("Blues Guitar", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 119) >> Program(1, 1, 27 )),
23:	Scene("Overdriven Guitar", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 30 )),
24:	Scene("French Horn", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 61 )),
25:	Scene("Tenor Sax", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 67 )),
26:	Scene("Oboe", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 69 )),
27:	Scene("English Horn", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 70 )),
28:	Scene("Bassoon", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 71 )),
29:	Scene("Flute", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 74 )),
30:	Scene("Ocarina", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 80 )),
31:	Scene("Warm Pad", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 0) >> Program(1, 1, 90 )),
32:	Scene("Bass & Lead", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 0) >> Program(1, 1, 88 )),
33:	Scene("New Age Pad", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 0) >> Program(1, 1, 89 )),
34:	Scene("Vibraphone", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 12 )),
35:	Scene("Tubular Bells", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 15 )),
36:	Scene("Timpani", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 48 )),
37:	Scene("Tinkle Bell", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 0) >> Program(1, 1, 113 )),
38:	Scene("Orchestra Hit", Pass(), Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 56 )),
39:	Scene("Standard Kit 1", Pass(), Ctrl(1, 1, 0,127) >> Ctrl(1, 1, 32, 0) >> Program(1, 1, 1 )),

112:	Scene("Panic!",
			Pass(),
			#Ctrl(port, channel, ctrl, value)
			# napred si v pre nastavi rejstriky na 2.a 3. kanal a pak prichozi noty splituje do jednotlivych kanalu, podle vyse noty.
			Panic(True)
			),
128:	Scene("Split piano/bass",
			KeySplit('f#2', Channel(2),Channel(3)), #f#2 včetně jde nahoru
			#Ctrl(port, channel, ctrl, value)
			# napred si v pre nastavi rejstriky na 2.a 3. kanal a pak prichozi noty splituje do jednotlivych kanalu, podle vyse noty.
			[Panic(True),
			 Ctrl(1, 3, 0,108) 	>> Ctrl(1, 3, 32, 0) 	>> Program(1, 3, 1  ), #piano
			 Ctrl(1, 2, 0,0) 	>> Ctrl(1, 2, 32, 112) 	>> Program(1, 2, 34 )] #bass
			),
127:	Scene("Split piano+housle/bass",
			KeySplit('f#2', Channel(2),[Channel(3),Channel(4)]), #f#2 včetně jde nahoru
			#Ctrl(port, channel, ctrl, value)
			[Panic(True),
			 Ctrl(1, 4, 0,0) 	>> Ctrl(1, 4, 32, 40) 	>> Program(1, 4, 50 ),	#housle
			 Ctrl(1, 3, 0,108) 	>> Ctrl(1, 3, 32, 0) 	>> Program(1, 3, 1  ),	#piano
			 Ctrl(1, 2, 0,0) 	>> Ctrl(1, 2, 32, 112) 	>> Program(1, 2, 34 )]	#bass
			),
126:	Scene("Split vibrafone/bass",
			KeySplit('f#2', Channel(2),Channel(3)), #f#2 včetně jde nahoru
			#Ctrl(port, channel, ctrl, value)
			# napred si v pre nastavi rejstriky na 2.a 3. kanal a pak prichozi noty splituje do jednotlivych kanalu, podle vyse noty.
			[Panic(True),
			 Ctrl(1, 3, 0,0) 	>> Ctrl(1, 3, 32, 112) 	>> Program(1, 3, 12 ), #vibrafone
			 Ctrl(1, 2, 0,0) 	>> Ctrl(1, 2, 32, 112) 	>> Program(1, 2, 34 )] #bass
			),
125:	Scene("Mixtura", Pass() // Transpose(7) // Transpose(12)), #ProgramFilter(program, ...)
124:	Scene("Split hluboky/vysoky housle",
			KeySplit('f3', Transpose(-12) ,Pass()),
			[	Panic(True),
				Ctrl(1, 1, 0,0) >> Ctrl(1, 1, 32, 112) >> Program(1, 1, 49 )
				]
			),
#123:	Scene("Panic!",
			#Pass(),
			#Panic(True)
			#),
123:	Scene("Split hluboky/vysoky",
			KeySplit('c3', Transpose(-12) ,Transpose(12) ),
			Panic(True)
			),

    }, #toto je konec scenes={}
    #control =  Filter(PROGRAM) >> SceneSwitch(), #~Filter(CTRL) >>
    #pre = ~Filter(PROGRAM),
    #control =  ChannelSplit({(1,2,3,4,5,6,7,8,9,10,11,12,13,14,15): Filter(CTRL|PROGRAM), (16): Filter(PROGRAM) >> SceneSwitch() >> Panic(True)  }),
    control =  Filter(PROGRAM) >> SceneSwitch() >> Panic(True)
    #pre = ~Filter(PROGRAM) >> ~ChannelFilter(15)
    #post =
    #pre = ~Filter(PROGRAM) >> ~ChannelFilter(15)
	#Print(string=...) # vypise cokoli

)
